;  Source name     : EAT5.ASM
;  Executable name : EAT5.COM
;  Code model:     : Real mode flat model
;  Version         : 1.0
;  Created date    : 9/15/1999
;  Last update     : 9/18/1999
;  Author          : Jeff Duntemann
;  Description     : A simple example of a DOS .COM file programmed for
;                    real mode flat model, using NASM 0.98 and ALINK.
;                    This program demonstrates how multi-line macros are
;                    used with NASM.

[BITS 16]                   ; Set 16 bit code generation
[ORG 0100H]                 ; Set code start address to 100h (COM file)

[SECTION .text]             ; Section containing code

%include "BOOK\MYLIB.MAC"        ; Load in screen control macro library

START:                      ; This is where program execution begins:

           Clear VidOrigin,07B0H,4000  ; Replace B0 with 20 for space clear

           GotoXY 14H,09H              ; Position cursor
           Write Eat1,Eat1Length       ;  and display first text line

           GotoXY 14H,0AH              ; Position cursor
           Writeln Eat2,Eat2Length     ;  and display second text line

           mov  AH,4CH      ; Terminate process DOS service
           mov  AL,0        ; Pass this value back to ERRORLEVEL
           int  21H         ; Control returns to DOS


[SECTION .data]              ; Section containing initialised data

LRXY       DW      184FH ; 18H = 24D; 4FH = 79D; 0-based XY of LR screen corner

VidOrigin  DD      0B8000000H   ; Change to 0B0000000H if you have a mono CRT!
Eat1       DB      "Eat at Joe's..."
Eat1Length EQU $-Eat1
Eat2       DB      "...ten million flies can't ALL be wrong!"
Eat2Length EQU $-Eat2
CRLF       DB      0DH,0AH


