;  Source name     : ANSWER.ASM
;  Executable name : ANSWER
;  Version         : 1.0
;  Created date    : 11/1/1999
;  Last update     : 11/22/1999
;  Author          : Jeff Duntemann
;  Description     : A demonstration of how to call printf from in assembly, using
;    NASM 0.98
;
;  Build using these commands:
;    nasm -f elf answer.asm
;    gcc answer.o -o answer
;
			
[SECTION .text]			; Section containing code

extern printf						
global main			; Required so linker can find entry point
	
main:
        push ebp		; Set up stack frame for debugger
	mov ebp,esp
	push ebx		; Program must preserve ebp, ebx, esi, & edi
	push esi
	push edi
	;;; Everything before this is boilerplate; use it for all ordinary apps!
	
	push dword 42		; Push number to display onto the stack
	push dword formatDec	; Push long pointer to message string
	call printf		; Call printf to display message & number
	add esp,8		; Clean up stack after call

	;;; Everything after this is boilerplate; use it for all ordinary apps!
	pop edi			; Restore saved registers
	pop esi
	pop ebx
	mov esp,ebp		; Destroy stack frame before returning
	pop ebp
	ret			; Return control to Linux


[SECTION .data]			; Section containing initialised data
		
formatDec  db "The answer is %d and don't you forget it!",10,0
	
[SECTION .bss]			; Section containing uninitialized data





























