;  Source name     : SHOWENV.ASM
;  Executable name : SHOWENV
;  Version         : 1.0
;  Created date    : 10/1/1999
;  Last update     : 12/11/1999
;  Author          : Jeff Duntemann
;  Description     : A demo that shows how to access Linux system environment
;		      variables using environment pointers passed on the stack.
;
;  Build using these commands:
;    nasm -f elf showenv.asm
;    gcc showenv.o -o showenv
;

	
		
[SECTION .text]			; Section containing code
					
global main			; Required so linker can find entry point
extern printf			; Notify linker that we're calling printf
		
main:
        push ebp		; Set up stack frame for debugger
	mov ebp,esp
	push ebx		; Program must preserve ebp, ebx, esi, & edi
	push esi
	push edi
	;;; Everything before this is boilerplate; use it for all ordinary apps!	

	mov ebx,[ebp+16]	; Load pointer to environment table into ebx
	xor esi,esi		; Clear esi to 0
showit:
	mov eax,dword [ebx+esi*4]  ; Push address of an item on the stack
	cmp dword eax,0		; Is it a null pointer?
	jz exit			; If so, we're done.
	push eax		; If not, push pointer to item on the stack
	push esi		; Push arg number on the stack
	push dword argmsg	; Push address of display string on the stack
	call printf		; Display the arg number and arg
	add esp,12		; Clean up stack after printf call
	inc esi			; Bump arg number to next arg...
	jmp showit		; ...and loop back again!

exit:		
	;;; Everything after this is boilerplate; use it for all ordinary apps!
	pop edi			; Restore saved registers
	pop esi
	pop ebx
	mov esp,ebp		; Destroy stack frame before returning
	pop ebp
	ret			; Return control to Linux


[SECTION .data]			; Section containing initialised data
		
argmsg	db "Environment variable %d: %s",10,0
		
[SECTION .bss]			; Section containing uninitialized data





























